import pygame
from pygame.locals import *

class Animation(object):
    def __init__(self, name, frame_list, speed):
        """Creates an animation from an array of images.

        Where a frame_list is a list of tuples:
        (image, image_pos)
        """
        self.name = name
        self.images = [image for image, _ in frame_list]
        self.image_poses = [pos for _, pos in frame_list]
        self.speed = speed
        self.size = self.image_poses[0][2], self.image_poses[0][3]
        
    def display(self, surface, pos, tick):
        tick /= self.speed
        tick %= len(self.images)
        surface.blit(self.images[tick], pos, self.image_poses[tick])
