import entity
import resources
import random
import item

def spastic_ai(self):
    pick = random.randint(0, 6)
    if pick == 0:
        self.move(-6, 0)
    elif pick == 1:
        self.move(6, 0)
    elif pick == 2:
        self.move(0, -10)
    elif pick == 3:
        self.move(6, -10)
    elif pick == 4:
        self.move(-6, -10)

def ground_ai(self):
    pick = self.plan
    if random.randint(0, 10) == 0:
        self.plan = random.randint(0, 5)
    elif pick == 6 or random.randint(0,2) == 0:
        pick = random.randint(0, 3)
    if pick == 0 and self.on_ground:
        self.move(-6, 0)
    elif pick == 1 and self.on_ground:
        self.move(6, 0)
        
def bird_ai(self):
    pick = self.plan
    if random.randint(0, 10) == 0:
        self.plan = random.randint(0, 7)
    elif pick == 6 or random.randint(0,2) == 0:
        pick = random.randint(0, 6)
    if pick == 0:
        self.move(-6, 0)
    elif pick == 1:
        self.move(6, 0)
    elif pick == 2:
        self.move(0, -10)
    elif pick == 3:
        self.move(6, -10)
    elif pick == 4:
        self.move(-6, -10)

def ground_jump_ai(self):
    pick = self.plan
    if random.randint(0, 10) == 0:
        self.plan = random.randint(0, 5)
    elif pick == 6 or random.randint(0,2) == 0:
        pick = random.randint(0, 3)
    if pick == 0 or pick == 1:
        if self.on_ground:
            self.jump = random.randint(8, 16)
    if self.jump > 0:
        self.move(0, -10)
        self.jump -= 1
    if pick == 0:
        self.move(-6, 0)
    elif pick == 1:
        self.move(6, 0)

class Bird(entity.Entity):
    def __init__(self, pos, level):
        super(Bird, self).__init__(pos, resources.animations["bird_r"], level)
        self.facing_left = False
        
    ai = spastic_ai

    def update(self):
        if self.dpos.x > 0 and self.facing_left:
            self.facing_left = False
            self.animation = resources.animations["bird_r"]
            self.dpos.x = 0
        elif self.dpos.x < 0 and not self.facing_left:
            self.facing_left = True
            self.animation = resources.animations["bird_l"]
            self.dpos.x = 0
        super(Bird, self).update()
        self.dpos.y += 6

class Bird2(entity.Entity):
    def __init__(self, pos, level):
        super(Bird2, self).__init__(pos, resources.animations["bird2_r"], level)
        self.facing_left = False
        self.plan = 0
        
    ai = bird_ai

    def update(self):
        if self.dpos.x > 0 and self.facing_left:
            self.facing_left = False
            self.animation = resources.animations["bird2_r"]
            self.dpos.x = 0
        elif self.dpos.x < 0 and not self.facing_left:
            self.facing_left = True
            self.animation = resources.animations["bird2_l"]
            self.dpos.x = 0
        super(Bird2, self).update()
        self.dpos.y += 6

class GBird(entity.Entity):
    def __init__(self, pos, level):
        super(GBird, self).__init__(pos, resources.animations["bird_r"], level)
        self.facing_left = False
        self.plan = 0
        self.jump = 0
        
    ai = ground_jump_ai
        
    def update(self):
        if self.dpos.x > 0 and self.facing_left:
            self.facing_left = False
            self.animation = resources.animations["bird_r"]
            self.dpos.x = 0
        elif self.dpos.x < 0 and not self.facing_left:
            self.facing_left = True
            self.animation = resources.animations["bird_l"]
            self.dpos.x = 0
        super(GBird, self).update()
        self.dpos.y += 6

class Butterfly(entity.Entity):
    def __init__(self, pos, level):
        super(Butterfly, self).__init__(pos, resources.animations["butterfly_r"], level)
        self.facing_left = False
        self.plan = 0

    ai = spastic_ai
    
    def update(self):
        if self.dpos.x > 0 and self.facing_left:
            self.facing_left = False
            self.animation = resources.animations["butterfly_r"]
            self.dpos.x = 0
        elif self.dpos.x < 0 and not self.facing_left:
            self.facing_left = True
            self.animation = resources.animations["butterfly_l"]
            self.dpos.x = 0
        super(Butterfly, self).update()
        self.dpos.y += 6

class Cloud2(entity.Entity):
    def __init__(self, pos, level):
        super(Cloud2, self).__init__(pos, resources.animations["cloud2"], level)
        self.facing_left = False
        self.plan = 0

    def update(self):
        super(Cloud2, self).update()
        self.dpos.x = -1
        if self.pos.x + self.pos.w < 0:
            self.pos.x = self.level.get_total_size()[0]

    def check_collision(self, tilelayer):
        pass

class Cloud(entity.Entity):
    def __init__(self, pos, level):
        super(Cloud, self).__init__(pos, resources.animations["cloud"], level)
        self.facing_left = False
        self.plan = 0

    def update(self):
        super(Cloud, self).update()

        self.dpos.x = -1
        if self.pos.x + self.pos.w < 0:
            self.pos.x = self.level.get_total_size()[0]

    def check_collision(self, tilelayer):
        pass

class Plane(entity.Entity):
    def __init__(self, pos, level):
        super(Plane, self).__init__(pos, resources.animations["plane"], level)
        self.facing_left = False
        self.plan = 0

    def update(self):
        super(Plane, self).update()

        self.dpos.x = -10
        if self.pos.x + self.pos.w < 0:
            self.pos.x = self.level.get_total_size()[0] + 2000

        if random.randint(0, 30) == 0:
            self.plan = random.randint(-1, 1)

        self.dpos.y = self.plan
        if self.dpos.y < 0 and self.pos.y == 0:
            self.dpos.y = 0
        elif self.dpos.y > 0 and self.pos.y >= 50:
            self.dpos.y = 0

    def check_collision(self, tilelayer):
        pass

class Tree(entity.Entity):
    def __init__(self, pos, level):
        super(Tree, self).__init__(pos, resources.animations["tree"], level)
        self.facing_left = False
        self.plan = 0

    def update(self):
        super(Tree, self).update()

    def check_collision(self, tilelayer):
        pass

class Scientist(item.Item):
    def __init__(self, pos, level):
        super(Scientist, self).__init__(pos, level)
        self.animation = resources.animations["scientist"]
        self.facing_left = False
        self.plan = 0

    def update(self):
        super(Scientist, self).update()

class Sparks(entity.Entity):
    def __init__(self, pos, level):
        super(Sparks, self).__init__(pos, resources.animations["sparks"], level)

    def update(self):
        pass

class Robot(entity.Entity):
    def __init__(self, pos, level):
        super(Robot, self).__init__(pos, resources.animations["robot1_l"], level)
        self.facing_left = False
        self.plan = 0

    ai = ground_ai
    
    def update(self):
        if self.dpos.x > 0 and self.facing_left:
            self.facing_left = False
            self.animation = resources.animations["robot1_r"]
            self.dpos.x = 0
        elif self.dpos.x < 0 and not self.facing_left:
            self.facing_left = True
            self.animation = resources.animations["robot1_l"]
            self.dpos.x = 0
        super(Robot, self).update()

        self.dpos.y += 6

class Man(item.Item):
    def __init__(self, pos, level):
        super(Man, self).__init__(pos, level)
        self.animation = resources.animations["man_l"]
        self.facing_left = False
        self.plan = 0

    ai = ground_ai
    
    def update(self):
        if self.dpos.x > 0 and self.facing_left:
            self.facing_left = False
            self.animation = resources.animations["man_r"]
            self.dpos.x = 0
        elif self.dpos.x < 0 and not self.facing_left:
            self.facing_left = True
            self.animation = resources.animations["man_l"]
            self.dpos.x = 0
        super(Man, self).update()

class Robot2(entity.Entity):
    def __init__(self, pos, level):
        super(Robot2, self).__init__(pos, resources.animations["robot2_l"], level)
        self.facing_left = True
        self.plan = 0

    ai = ground_ai
    
    def update(self):
        if self.dpos.x > 0 and self.facing_left:
            self.facing_left = False
            self.animation = resources.animations["robot2_r"]
            self.dpos.x = 0
        elif self.dpos.x < 0 and not self.facing_left:
            self.facing_left = True
            self.animation = resources.animations["robot2_l"]
            self.dpos.x = 0
        super(Robot2, self).update()
        self.dpos.y += 6

class Tank(entity.Entity):
    def __init__(self, pos, level):
        super(Tank, self).__init__(pos, resources.animations["tank_down"], level)
        self.facing_left = False
        self.plan = 0

    ai = ground_ai
    
    def update(self):
        super(Tank, self).update()

        if random.randint(0, 10) == 0:
            if random.randint(0, 1) == 0:
                self.animation = resources.animations["tank_down"]
            else:
                self.animation = resources.animations["tank_up"]
        
        self.dpos.y += 6
