import entity
import resources
import random

class Item(entity.Entity):
    allowance = 4
    max_dist = 32
    speed = 6
    
    def __init__(self, pos, level):
        super(Item, self).__init__(pos, resources.animations["crate"], level)
        self.holder = None
        
    def update(self):
        super(Item, self).update()
        if self.holder is None:
            if self.on_ground:
                self.dpos.y += 1 # Horrible hack to get items flat on the ground
            else:
                self.dpos.y += 8
        else:
            if self.holder.pos.x > self.pos.x + self.allowance:
                self.dpos.x += self.speed
            if self.holder.pos.x < self.pos.x - self.allowance:
                self.dpos.x -= self.speed
            if self.holder.pos.y + self.holder.pos.h > self.pos.y + self.allowance:
                self.dpos.y += self.speed
            if self.holder.pos.y + self.holder.pos.h < self.pos.y - self.allowance:
                self.dpos.y -= self.speed
            if (self.holder.pos.x > self.pos.x + self.max_dist
                or self.holder.pos.x < self.pos.x - self.max_dist
                or self.holder.pos.y > self.pos.y + self.max_dist
                or self.holder.pos.y + self.holder.pos.h < self.pos.y - self.max_dist):
                self.holder = None
