import pygame
from pygame.locals import *

class State(object):
    """Base class for Game states.

    A game state stores all the current information.
    A good idiom for substates is to store their parent state, and then
    restore that as the state when exiting.
    """
    def __init__(self, engine):
        self.engine = engine

    def display(self, screen):
        pass

    def update(self):
        pass
    
    def handle_event(self, event):
        pass

    def on_exit(self):
        pass
