import pygame
from pygame.locals import *

import menu
import state
import text

class Win(state.State):
    def __init__(self, engine, game):
        super(Win, self).__init__(engine)
        self.game = game
        self.text = text.Text(font=engine.l_font, text="You have won.", color=(255,255,0))
        self.text.center_x(0, self.engine.width)
        self.text.center_y(0, self.engine.height)
        self.stext = text.Text(font=engine.l_font, text="You have won.", color=(0,0,0))
        self.stext.center_x(0, self.engine.width)
        self.stext.center_y(0, self.engine.height)
        self.stext.pos.x += 4
        self.stext.pos.y += 4
        
    def display(self, screen):
        self.game.display(screen)
        self.stext.display(screen)
        self.text.display(screen)
        
    def update(self):
        pass
    
    def handle_event(self, event):
        if event.type == KEYDOWN:
            if event.key == K_ESCAPE or event.key == K_SPACE or event.key == K_RETURN:
                pygame.mixer.music.stop()
                self.engine.set_state(menu.Menu(self.engine))
